-------     =================================================================
------------   showing a false solution of critical section access control
-------     =================================================================


-- here several processes may detect concurrently that Busy is False (test)
-- and in a second step, concurrently with others, set Busy to True (set) 
-- a correct version would requires a test and set like atomic operation 

   package body Simpleton is
	-- initialisation protocol
	Busy : Boolean := False;			-- a process is already busy in its critical section
	
	procedure Enter(Requestor : in Global.Process_Id) is 
	begin 
		while Busy loop null; end loop; -- waits until no process is in a critical section
		Busy := True;					-- critical section reservation
	end Enter;
	
	procedure Quit(Requestor : in Global.Process_Id) is 
	begin 
		Busy := False; 
	end Quit;
	
   begin
    -- initialisation protocol continued if necessary
	null;
   end Simpleton;
