-------------------------------------------------------------------
-----  Dekker solution (1965) for mutual exclusion between 2 processes

-- before entering in critical section
-- each process indicates its request to the peer
-- in case of conflict, priority is used and the non priority process withdraws its request
-- the priority holder waits until it is alone to set a request before entering its critical section
-- when quitting, priority is given to the peer in case of conflicting requests


package body Dekker_2 is
	-- initialisation protocol
	Candidat : array (Global.Process_Id) of Boolean;  -- candidacy 
    Priority :  Global.Process_Id := Global.Process_Id'First ;  -- current priority holder 
	
	procedure Enter(Requestor : in Global.Process_Id) is 
		Peer : Process_Id := Requestor + 1;  -- the other process
	begin            
		Candidat(Requestor) := True ;			-- candidacy
		while Candidat(Peer) loop				-- conflicting candidacies
            while Priority = Peer loop
               Candidat(Requestor) := False;	-- not its turn
            end loop;							
            Candidat(Requestor) := True ;		-- forcing the peer to withdraw
		end loop; --entree en S.C.;
	end Enter;
	
	
	procedure Quit(Requestor : in Global.Process_Id) is
		Peer : Process_Id := Requestor + 1;  -- the other process
	begin 
		Candidat(Requestor) := False ;   
        Priority := Peer;
	end Quit;
  
end Dekker_2;

   
  
