-------     =================================================================
------------   Peterson algorithm (1981) for mutual exclusion between 2 processes

-- before entering in critical section
-- each process indicates its request to the peer
-- in case of conflict, a dynamic choice is made and the latest requestor waits
-- for this, each requestor writes its name once in a variable indicating the victim 
-- and before entering, the name of the victim is checked by each process,
-- it as the last writer is not overwritten it remains the victim
-- avoids deadlock and provides strong fearness
-- since a very fast process will very fast become a victim

-------     =================================================================


   package body Peterson_2 is
	
	-- initialisation protocol
	Candidat : array (Global.Process_Id) of Boolean;  -- candidacy 
    Victim :  Global.Process_Id := Global.Process_Id'First ;  -- current victim name  
	
	procedure Enter(Requestor : in Global.Process_Id) is 
		Peer : Process_Id := Requestor + 1;		-- the other process
	begin 
		Candidat(Requestor) := True ;			-- candidacy
		Victim := Requestor;					-- modified once
		while Candidat(Peer) and Victim = Requestor loop
			null;
		end loop;
	end Enter;
	
	procedure Quit(Requestor : in Global.Process_Id) is 
	begin
		Candidat(Requestor) := False ;
	end Quit;
  
   end Peterson_2;
